// Kill Stuff
AddDamageType("Assault_Rifle",   '<bitmap:add-ons/Weapon_Package_HK/Images/CI_AssaultRifle> %1',    '%2 <bitmap:add-ons/Weapon_Package_HK/Images/CI_AssaultRifle> %1',0.75,1);

// Item Data
datablock ItemData(Assault_RifleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	
	// Assault_Rifle Item Properties
	shapeFile = "./Models/Assault_Rifle.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	//gui stuff
	uiName = "[HK] Assault Rifle";
	iconName = "./Icons/Icon_Assault_Rifle";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1";

	 // Dynamic properties defined by the scripts
	image = Assault_RifleImage;
	canDrop = true;

	RYG_Reloads = 1;		// This weapon can reload!
	RYG_ClipSize = 24;		// Max clip size for this weapon.
	RYG_MaxAmmo = 240;    // Max ammo for this item.
};

// Weapon Image
datablock ShapeBaseImageData(Assault_RifleImage)
{
	// Assault_Rifle Image properties
	shapeFile = "./Models/Assault_Rifle.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = true;

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "WeaponImage";

    // Projectile && Ammo.
    item = Assault_RifleItem;
	ammo = " ";
    projectile = gunProjectile;
    projectileType = Projectile;

    casing = GunShellDebris;
    shellExitDir        = "1.0 0.1 1.0";
    shellExitOffset     = "0 0 0";
    shellExitVariance   = 10.0;	
    shellVelocity       = 5.0;

    //melee particles shoot from eye node for consistancy
    melee = false;
    //raise your arm up or not
    armReady = true;
	
	doColorShift = true;
    colorShiftColor = Assault_RifleItem.colorShiftColor; 

	// Rykuta's stuffings.
	RYG_Support = 1;
	
	// Accuracy and recoil, biggest chunk.
	RYG_Accuracy = 0.0005;		// First bullet's accuracy.
	RYG_RecoilAdd = 0.00033;	// Amount of spread added per shot under time.
	RYG_RecoilSub = 0.001;	// Amount of spread reduced when gun has stopped spam firing.
	RYG_RecoilTick = 200;		// Delay between each shot required for the recoil to be reduced.
	RYG_MovementPer = 160;		// Percent of recoil generated due to movement. (If currenlty moving)
	RYG_CrouchPer = 40;      	// Percent of recoil generated while player is crouching. Does not stack with bipod. (Bipod has priority)
	RYG_MoveTimeout = 150;   	// Delay between last time moving and full recovery from moving.
	RYG_MaxRecoil = 0.003;		// Maximum recoil can reach.
	RYG_Oversight = 0.0055;		// Animation becomes more aggressive after this recoil is reached.
	
	RYG_MaxDmg = 14;		// Max damage at optimum Range.
	RYG_MinDmg = 8;		// Min damage at worst range.
	RYG_FalloffMax = 140;	// Range when bullet is at lowest damage. (In TorqueUnits)
	RYG_FalloffMin = 35;	// Range before bullet starts to lose damage. (In TorqueUnits)
	RYG_Headshot = 1.1;		// Multiplier for head damage.
	
	
	// Bipod Stuff
	RYG_Bipod = 0;			// Gives the weapon the ability to utilize a bipod.
	
	// Sound Stuff
	RYG_BoltSound = MedBoltSound;			// Sound name for bolt pull.
	RYG_ClipInSound = MedInSound;			// Clip In Sound Name.
	RYG_ClipOutSound = MedOutSound;			// Clip Out Sound Name.
   
    // Images have a state system which controls how the animations
    // are run, which sounds are played, script callbacks, etc. This
    // state system is downloaded to the client so that clients can
    // predict state changes and animate accordingly.  The following
    // system supports Gun ready->fire->reload transitions as
    // well as a no-ammo->dryfire idle state.
    raycastWeaponRange = 200; //varies
	raycastWeaponTargets =
        $TypeMasks::PlayerObjectType |    //AI/Players
        $TypeMasks::StaticObjectType |    //Static Shapes
        $TypeMasks::TerrainObjectType |    //Terrain
        $TypeMasks::VehicleObjectType |    //Terrain
        $TypeMasks::FXBrickObjectType;    //Bricks
    raycastExplosionProjectile = RyZMedEProjectile;
    raycastExplosionBrickSound = ObjHitASound;
    raycastExplosionPlayerSound = PlayerHitASound;
    raycastDirectDamage = 1;                        // Bot Damage
    raycastDirectDamageType = $DamageType::Assault_Rifle;   
    raycastSpreadAmt = 0.00075; //varies            // This value is used by bots, not the player.
    raycastSpreadCount = 1;                         // Shotguns will have more than 1
    raycastTracerProjectile = RyZMedTProjectile;
    raycastFromMuzzle = true;
    raycastImpactImpulse = 10;
   
     minShotTime = 0;   // Rapid Fire Fix?~

	// Main gun functionality  - - - - - - - - - - - - - - - - - - - - - - - - - - -
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 1.0;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	StateSequence[0]					= "use";
	StateSound[0]						= "MedDrawSound";
	StateScript[0]						= "onMount";
	
	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;
	stateScript[1]						= "onReady";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.0475;
	stateFire[2]                    	= true;
	stateSequence[2]                	= "fire";
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]       	  		= true;
	stateEmitter[2]						= RyZMedFlashEmitter;
	stateEmitterTime[2]					= 0.05;
	stateEmitterNode[2]					= "muzzleNode";
	stateWaitForTimeout[2]				= true;
	StateSequence[2]					= "fire";
	stateSound[2]						= RifleFireBSound;

	stateName[3] 						= "Smoke";
	stateEmitter[3]						= gunSmokeEmitter;
	stateEmitterTime[3]					= 0.03;
	stateEmitterNode[3]					= "muzzleNode";
	stateTimeoutValue[3]				= 0.001;
	stateTransitionOnTimeout[3]			= "LoadCheckA";

	// Reload checks  - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	stateName[6]						= "LoadCheckA";
	stateScript[6]						= "onLoadCheck";
	stateTimeoutValue[6]				= 0.001;
	stateTransitionOnTimeout[6]			= "LoadCheckB";
	
	stateName[7]						= "LoadCheckB";
	stateTransitionOnAmmo[7]			= "Ready";
	stateTransitionOnNoAmmo[7]			= "NoRoundsLeftA";
	
	// No Rounds Left States - - - - - - - - - - - - - - - - - - - - - - - -
	
	stateName[9]						= "NoRoundsLeftA";
	stateScript[9]						= "NoRoundsLeft";
	stateTimeoutValue[9]				= 0.01;
	stateTransitionOnTimeout[9]			= "NoRoundsLeftB";
	
	stateName[10]						= "NoRoundsLeftB";
	stateTimeoutValue[10]				= 0.01;
	stateTransitionOnNoAmmo[10]			= "ReloadFull";
	stateTransitionOnTriggerDown[10]	= "NoRoundsLeftC";
	
	stateName[11]						= "NoRoundsLeftC";
	stateScript[11]						= "BlankFire";
	stateTimeoutValue[11]				= 0.01;
	stateTransitionOnTriggerUp[11]		= "NoRoundsLeftB";
	
	// Reloads - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	// Regular Reload
	stateName[20]						= "Reload";
	stateScript[20]						= "OnClipRemoved";
	stateTimeoutValue[20]				= 1.0;
	stateTransitionOnTimeout[20]     	= "InsertClipA";
	stateWaitForTimeout[20]				= true;
	
	stateName[13]						= "InsertClipA";
	stateScript[13]						= "OnClipInserted";
	stateTimeoutValue[13]				= 1.25;
	stateTransitionOnTimeout[13]     	= "ReloadFinish";
	stateWaitForTimeout[13]				= true;
	
	// Full Reload
	stateName[21]						= "ReloadFull";
	stateScript[21]						= "OnClipRemoved";
	stateTimeoutValue[21]				= 1.0;
	stateTransitionOnTimeout[21]     	= "InsertClipB";
	stateWaitForTimeout[21]				= true;

	stateName[15]						= "InsertClipB";
	stateScript[15]						= "OnClipInserted";
	stateTimeoutValue[15]				= 1.25;
	stateTransitionOnTimeout[15]     	= "GunBolt";
	stateWaitForTimeout[15]				= true;

	stateName[16]						= "GunBolt";
	stateScript[16]						= "onGunBolt";
	stateTimeoutValue[16]				= 0.75;
	stateTransitionOnTimeout[16]     	= "ReloadFinish";
	stateWaitForTimeout[16]				= true;

	// Finish reloading
	stateName[17]						= "ReloadFinish";
	stateScript[17]						= "OnGunReloadFinished";
	stateTimeoutValue[17]				= 0.01;
	stateTransitionOnTimeout[17]     	= "Ready";
	stateWaitForTimeout[17]				= true;
};

function Assault_RifleImage::onFire(%this, %obj, %slot)
{
	%rand = getRandom(0, 2);
	if(%rand == 1)
	{
		%this.raycastExplosionBrickSound = ObjHitBSound;
		%this.raycastExplosionPlayerSound = PlayerHitBSound;
	}
	else if(%rand == 2)
	{
		%this.raycastExplosionBrickSound = ObjHitCSound;
		%this.raycastExplosionPlayerSound = PlayerHitCSound;
	}
	else
	{
		%this.raycastExplosionBrickSound = ObjHitASound;
		%this.raycastExplosionPlayerSound = PlayerHitASound;
	}
	parent::onFire(%this, %obj, %slot);
	%obj.playThread(2, plant);
}