// Kill Stuff
AddDamageType("HKShotgun",   '<bitmap:add-ons/Weapon_Package_HK/Images/CI_HKShotgun> %1',    '%2 <bitmap:add-ons/Weapon_Package_HK/Images/CI_HKShotgun> %1',0.75,1);

// Item Data
datablock ItemData(HKShotgunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	
	// HKShotgun Item Properties
	shapeFile = "./Models/Combat_Shotgun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	//gui stuff
	uiName = "[HK] Shotgun";
	iconName = "./Icons/Icon_HKShotgun";
	doColorShift = true;
	colorShiftColor = "0.4 0.4 0.4 1";

	 // Dynamic properties defined by the scripts
	image = HKShotgunImage;
	canDrop = true;

	RYG_Reloads = 1;		// This weapon can reload!
	RYG_ClipSize = 6;		// Max clip size for this weapon.
	RYG_NoExtraBullet = 1;	// You can't load 7 rounds into a 6 round pistol.
	
	// Weapon description for guis or w/e.
	RYG_Description = "A basic pump-action shotgun, decent damage, decent accuracy.";
};

// Weapon Image
datablock ShapeBaseImageData(HKShotgunImage)
{
	// HKShotgun Image properties
	shapeFile = "./Models/Combat_Shotgun.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = true;

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "WeaponImage";

    // Projectile && Ammo.
    item = HKShotgunItem;
	ammo = " ";
    projectile = gunProjectile;
    projectileType = Projectile;

    casing = GunShellDebris;
    shellExitDir        = "1.0 0.1 1.0";
    shellExitOffset     = "0 0 0";
    shellExitVariance   = 10.0;	
    shellVelocity       = 5.0;

    //melee particles shoot from eye node for consistancy
    melee = false;
    //raise your arm up or not
    armReady = true;
	
	doColorShift = true;
    colorShiftColor = HKShotgunItem.colorShiftColor; 

	// Rykuta's stuffings.
	RYG_Support = 1;
	   
	// Accuracy and recoil, biggest chunk.
	RYG_Accuracy = 0.003;	// First bullet's accuracy.
	RYG_RecoilAdd = 0.003;	// Amount of spread added per shot under time.
	RYG_RecoilSub = 0.002;	// Amount of spread reduced when gun has stopped spam firing.
	RYG_RecoilTick = 1000;	// Delay between each shot required for the recoil to be reduced.
	RYG_MovementPer = 200;	// Percent of recoil generated due to movement.
	RYG_CrouchPer = 50;      	// Percent of recoil generated while player is crouching. Does not stack with bipod. (Bipod has priority)
	RYG_MoveTimeout = 125;   	// Delay between last time moving and full recovery from moving.
	RYG_MaxRecoil = 0.03;	// Maximum recoil can reach.
	RYG_Oversight = 0.04;	// Animation becomes more aggressive after this recoil is reached.
	
	RYG_MaxDmg = 10;		// Max damage at optimum Range.
	RYG_MinDmg = 2;			// Min damage at worst range.
	RYG_FalloffMax = 35;	// Range when bullet is at lowest damage. (In TorqueUnits)
	RYG_FalloffMin = 2;		// Range before bullet starts to lose damage. (In TorqueUnits)
	RYG_Headshot = 1.25;	// Multiplier for head damage.
	
	RYG_Bipod = 0;			// Gives the weapon the ability to utilize a bipod.
	
	RYG_BoltSound = "ShotgunPumpASound";			// Sound name for shotgun Pump.
	RYG_ClipInSound = "RoundLoadSound";
	
	RYG_StoppingPower = 1;	// Will halt enemies in their tracks on impact.
   
    // Images have a state system which controls how the animations
    // are run, which sounds are played, script callbacks, etc. This
    // state system is downloaded to the client so that clients can
    // predict state changes and animate accordingly.  The following
    // system supports Gun ready->fire->reload transitions as
    // well as a no-ammo->dryfire idle state.
    raycastWeaponRange = 60; //varies
	raycastWeaponTargets =
        $TypeMasks::PlayerObjectType |    //AI/Players
        $TypeMasks::StaticObjectType |    //Static Shapes
        $TypeMasks::TerrainObjectType |    //Terrain
        $TypeMasks::VehicleObjectType |    //Terrain
        $TypeMasks::FXBrickObjectType;    //Bricks
    raycastExplosionProjectile = RyZMedEProjectile;
    raycastExplosionBrickSound = ObjHitASound;
    raycastExplosionPlayerSound = PlayerHitASound;
    raycastDirectDamage = 1;
    raycastDirectDamageType = $DamageType::HKShotgun;
    raycastSpreadAmt = 0.00075; //varies
    raycastSpreadCount = 9;
    raycastTracerProjectile = RyZSmallTProjectile;
    raycastFromMuzzle = true;
    raycastImpactImpulse = 10;
   

	// Main gun functionality  - - - - - - - - - - - - - - - - - - - - - - - - - - -
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.5;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	StateSequence[0]					= "use";
	StateSound[0]						= "SmallDrawSound";
	StateScript[0]						= "onMount";
	
	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;
	stateScript[1]						= "onReady";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.3;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateScript[2]                  	= "onFire";
	stateEmitter[2]						= RyZMedFlashEmitter;
	stateEmitterTime[2]					= 0.05;
	stateEmitterNode[2]					= "muzzleNode";
	stateWaitForTimeout[2]				= true;
	StateSequence[2]					= "fire";
	stateSound[2]						= ShotgunFireASound;

	stateName[3] 						= "Smoke";
	stateEmitter[3]						= gunSmokeEmitter;
	stateEmitterTime[3]					= 0.2;
	stateEmitterNode[3]					= "muzzleNode";
	stateTimeoutValue[3]				= 0.01;
	stateTransitionOnTimeout[3]			= "WaitForTriggerUp";
	
	stateName[8]						= "WaitForTriggerUp";
	stateScript[8]						= "WaitForTriggerUp";
	stateTransitionOnTriggerUp[8]		= "FireLoadCheckA";
	
	stateName[16]						= "Pump";
	stateScript[16]						= "onShotgunPump";
	stateTimeoutValue[16]				= 0.3;
	stateWaitForTimeout[16]				= true;
	stateTransitionOnTimeout[16]		= "Pause";
	stateSequence[16]					= "Reload";
	stateEjectShell[16]       	  		= true;
	
	stateName[23]						= "Pause";
	stateScript[23]						= "onPause";
	stateTimeoutValue[23]				= 0.3;
	stateWaitForTimeout[23]				= true;
	stateTransitionOnTimeout[23]     	= "Ready";

	// Reload checks  - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	stateName[6]						= "LoadCheckA";
	stateScript[6]						= "onLoadCheck";
	stateTimeoutValue[6]				= 0.01;
	stateTransitionOnTimeout[6]			= "LoadCheckB";
	
	stateName[7]						= "LoadCheckB";
	stateTransitionOnAmmo[7]			= "Ready";
	stateTransitionOnNoAmmo[7]			= "NoRoundsLeftA";
	
	stateName[13]						= "FireLoadCheckA";
	stateScript[13]						= "onLoadCheck";
	stateTimeoutValue[13]				= 0.01;
	stateTransitionOnTimeout[13]		= "FireLoadCheckB";
	
	stateName[15]						= "FireLoadCheckB";
	stateTransitionOnAmmo[15]			= "Pump";
	stateTransitionOnNoAmmo[15]			= "NoRoundsLeftA";
	
	
	// No Rounds Left States - - - - - - - - - - - - - - - - - - - - - - - -
	
	stateName[9]						= "NoRoundsLeftA";
	stateScript[9]						= "NoRoundsLeft";
	stateTimeoutValue[9]				= 0.01;
	stateTransitionOnTimeout[9]			= "NoRoundsLeftB";
	
	stateName[10]						= "NoRoundsLeftB";
	stateTimeoutValue[10]				= 0.01;
	stateTransitionOnNoAmmo[10]			= "ReloadFull";
	stateTransitionOnTriggerDown[10]	= "NoRoundsLeftC";
	
	stateName[11]						= "NoRoundsLeftC";
	stateScript[11]						= "BlankFire";
	stateTimeoutValue[11]				= 0.01;
	stateTransitionOnTriggerUp[11]		= "NoRoundsLeftB";
	
	// Reloads - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	// Regular Reload
	stateName[12]						= "Reload";
	stateScript[12]						= "OnRoundInserted";
	stateTimeoutValue[12]				= 0.55;
	stateTransitionOnTimeout[12]     	= "ReloadFinish";
	stateWaitForTimeout[12]				= true;
	
	// Full Reload
	stateName[14]						= "ReloadFull";
	stateScript[14]						= "OnRoundInserted";
	stateTimeoutValue[14]				= 0.55;
	stateTransitionOnTimeout[14]     	= "ReloadFinishFull";
	stateWaitForTimeout[14]				= true;

	// Finish reloading
	stateName[17]						= "ReloadFinish";
	stateScript[17]						= "OnShottyReloaded";
	stateTimeoutValue[17]				= 0.01;
	stateTransitionOnTimeout[17]     	= "ReloadCheckA";
	stateWaitForTimeout[17]				= true;
	
	stateName[18]						= "ReloadFinishFull";
	stateScript[18]						= "OnShottyReloaded";
	stateTimeoutValue[18]				= 0.01;
	stateTransitionOnTimeout[18]     	= "ReloadCheckC";
	stateWaitForTimeout[18]				= true;
	
	// Reload Checks
	stateName[19]						= "ReloadCheckA";
	stateScript[19]						= "onReloadCheck";
	stateTimeoutValue[19]				= 0.01;
	stateTransitionOnTriggerDown[19]	= "Ready";
	stateTransitionOnTimeout[19]     	= "ReloadCheckB";
	
	stateName[20]						= "ReLoadCheckB";
	stateTransitionOnAmmo[20]			= "Ready";
	stateTransitionOnNoAmmo[20]			= "Reload";
	
	stateName[21]						= "ReloadCheckC";
	stateScript[21]						= "onReloadCheck";
	stateTimeoutValue[21]				= 0.01;
	stateTransitionOnTriggerDown[21]	= "Pump";
	stateTransitionOnTimeout[21]     	= "ReloadCheckD";
	
	stateName[22]						= "ReLoadCheckD";
	stateTransitionOnAmmo[22]			= "Pump";
	stateTransitionOnNoAmmo[22]			= "ReloadFull";
};

function HKShotgunImage::onFire(%this, %obj, %slot)
{
	%rand = getRandom(0, 2);
	if(%rand == 1)
	{
		%this.raycastExplosionBrickSound = ObjHitBSound;
		%this.raycastExplosionPlayerSound = PlayerHitBSound;
	}
	else if(%rand == 2)
	{
		%this.raycastExplosionBrickSound = ObjHitCSound;
		%this.raycastExplosionPlayerSound = PlayerHitCSound;
	}
	else
	{
		%this.raycastExplosionBrickSound = ObjHitASound;
		%this.raycastExplosionPlayerSound = PlayerHitASound;
	}
	parent::onFire(%this, %obj, %slot);
	%obj.playThread(2, plant);
}