// Kill Stuff
AddDamageType("HKSniperRifle",   '<bitmap:add-ons/Weapon_Package_HK/Images/CI_HKSniperRifle> %1',    '%2 <bitmap:add-ons/Weapon_Package_HK/Images/CI_HKSniperRifle> %1',0.75,1);

// Item Data
datablock ItemData(HKSniperRifleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system
	
	// HKSniperRifle Item Properties
	shapeFile = "./Models/Sniper_Rifle.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	//gui stuff
	uiName = "[HK] Sniper Rifle";
	iconName = "./Icons/Icon_HKSniperRifle";
	doColorShift = true;
	colorShiftColor = "0.6 0.6 0.6 1";

	 // Dynamic properties defined by the scripts
	image = HKSniperRifleImage;
	canDrop = true;

	RYG_Reloads = 1;		// This weapon can reload!
	RYG_ClipSize = 6;		// Max clip size for this weapon.
	RYG_NoExtraBullet = 1;
	RYG_MaxAmmo = 60;    // Max ammo for this item.
	
	// Weapon description for guis or w/e.
	RYG_Description = "A highly accurate rifle, for all your half-sniping needs.";
};

// Weapon Image
datablock ShapeBaseImageData(HKSniperRifleImage)
{
	// HKSniperRifle Image properties
	shapeFile = "./Models/Sniper_Rifle.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );

	// When firing from a point offset from the eye, muzzle correction
	// will adjust the muzzle vector to point to the eye LOS point.
	// Since this weapon doesn't actually fire from the muzzle point,
	// we need to turn this off.  
	correctMuzzleVector = true;

	// Add the WeaponImage namespace as a parent, WeaponImage namespace
	// provides some hooks into the inventory system.
	className = "WeaponImage";

    // Projectile && Ammo.
    item = HKSniperRifleItem;
	ammo = " ";
    projectile = gunProjectile;
    projectileType = Projectile;

    casing = GunShellDebris;
    shellExitDir        = "1.0 0.1 1.0";
    shellExitOffset     = "0 0 0";
    shellExitVariance   = 10.0;	
    shellVelocity       = 5.0;

    //melee particles shoot from eye node for consistancy
    melee = false;
    //raise your arm up or not
    armReady = true;
	
	doColorShift = true;
    colorShiftColor = HKSniperRifleItem.colorShiftColor; 

	// Rykuta's stuffings.
	RYG_Support = 1;
	
    // Accuracy and recoil, biggest chunk.
	RYG_Accuracy = 0.00001;		// First bullet's accuracy.
	RYG_RecoilAdd = 0.002;	// Amount of spread added per shot under time.
	RYG_RecoilSub = 0.005;	// Amount of spread reduced when gun has stopped spam firing.
	RYG_RecoilTick = 1650;		// Delay between each shot required for the recoil to be reduced.
	RYG_MovementPer = 200;		// Percent of recoil generated due to movement. (If currenlty moving)
	RYG_CrouchPer = 25;      	// Percent of recoil generated while player is crouching. Does not stack with bipod. (Bipod has priority)
	RYG_MoveTimeout = 100;   	// Delay between last time moving and full recovery from moving.
	RYG_MaxRecoil = 0.0075;		// Maximum recoil can reach.
	RYG_Oversight = 0.0095;		// Animation becomes more aggressive after this recoil is reached.
	
	RYG_MaxDmg = 34;		// Max damage at optimum Range.
	RYG_MinDmg = 22;			// Min damage at worst range.
	RYG_FalloffMax = 240;	// Range when bullet is at lowest damage. (In TorqueUnits)
	RYG_FalloffMin = 60;	// Range before bullet starts to lose damage. (In TorqueUnits)
	RYG_Headshot = 2.0;		// Multiplier for head damage.
	
    // This sniper is more of a hunting rifle, No Bipod.
	RYG_Bipod = 0;			// Gives the weapon the ability to utilize a bipod.
	
	RYG_ClipInSound = "RoundLoadSound";	// Reload sound
   
    // Images have a state system which controls how the animations
    // are run, which sounds are played, script callbacks, etc. This
    // state system is downloaded to the client so that clients can
    // predict state changes and animate accordingly.  The following
    // system supports Gun ready->fire->reload transitions as
    // well as a no-ammo->dryfire idle state.
    raycastWeaponRange = 400; //varies               // Range is the max the bullet can hit, I'm not quite sure why Spacey put the "varies" word by it, because really, it doesn't.
	raycastWeaponTargets =
        $TypeMasks::PlayerObjectType |    //AI/Players
        $TypeMasks::StaticObjectType |    //Static Shapes
        $TypeMasks::TerrainObjectType |    //Terrain
        $TypeMasks::VehicleObjectType |    //Terrain
        $TypeMasks::FXBrickObjectType;    //Bricks
    raycastExplosionProjectile = RyZMAssiveEProjectile;
    raycastExplosionBrickSound = ObjHitASound;
    raycastExplosionPlayerSound = PlayerHitASound;
    raycastDirectDamage = 10;                        // Bot Damage
    raycastDirectDamageType = $DamageType::HKSniperRifle;   
    raycastSpreadAmt = 0.00075; //varies            // This value is used by bots, not the player.
    raycastSpreadCount = 1;                         // Shotguns will have more than 1
    raycastTracerProjectile = RyZMassiveTProjectile;
    raycastFromMuzzle = true;
    raycastImpactImpulse = 10;
   

	// Main gun functionality  - - - - - - - - - - - - - - - - - - - - - - - - - - -
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.5;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	StateSequence[0]					= "use";
	StateSound[0]						= "MedDrawSound";
	StateScript[0]						= "onMount";
	
	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "ReloadFull";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;
	stateScript[1]						= "onReady";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.125;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]       	  		= true;
	stateEmitter[2]						= RyZLargeFlashEmitter;
	stateEmitterTime[2]					= 0.05;
	stateEmitterNode[2]					= "muzzleNode";
	stateWaitForTimeout[2]				= true;
	StateSequence[2]					= "fire";
	stateSound[2]						= SniperFireCSound;

	stateName[3] 						= "Smoke";
	stateEmitter[3]						= gunSmokeEmitter;
	stateEmitterTime[3]					= 0.3;
	stateEmitterNode[3]					= "muzzleNode";
	stateTimeoutValue[3]				= 0.01;
	stateTransitionOnTimeout[3]			= "WaitForTriggerUp";
	
	stateName[8]						= "WaitForTriggerUp";
	stateScript[8]						= "WaitForTriggerUp";
	stateTransitionOnTriggerUp[8]		= "FireLoadCheckA";

	// Reload checks  - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	stateName[6]						= "LoadCheckA";
	stateScript[6]						= "onLoadCheck";
	stateTimeoutValue[6]				= 0.01;
	stateTransitionOnTimeout[6]			= "LoadCheckB";
	
	stateName[7]						= "LoadCheckB";
	stateTransitionOnAmmo[7]			= "Ready";
	stateTransitionOnNoAmmo[7]			= "NoRoundsLeftA";

	stateName[21]						= "FireLoadCheckA";
	stateScript[21]						= "onLoadCheck";
	stateTimeoutValue[21]				= 0.01;
	stateTransitionOnTimeout[21]		= "FireLoadCheckB";
	
	stateName[22]						= "FireLoadCheckB";
	stateTransitionOnAmmo[22]			= "BoltPull";
	stateTransitionOnNoAmmo[22]			= "NoRoundsLeftA";
	
	// No Rounds Left States - - - - - - - - - - - - - - - - - - - - - - - -
	
	stateName[9]						= "NoRoundsLeftA";
	stateScript[9]						= "NoRoundsLeft";
	stateTimeoutValue[9]				= 0.01;
	stateTransitionOnTimeout[9]			= "NoRoundsLeftB";
	
	stateName[10]						= "NoRoundsLeftB";
	stateTimeoutValue[10]				= 0.01;
	stateTransitionOnNoAmmo[10]			= "ReloadFull";
	stateTransitionOnTriggerDown[10]	= "NoRoundsLeftC";
	
	stateName[11]						= "NoRoundsLeftC";
	stateScript[11]						= "BlankFire";
	stateTimeoutValue[11]				= 0.01;
	stateTransitionOnTriggerUp[11]		= "NoRoundsLeftB";

	// Bolt Action - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	stateName[17]						= "BoltPull";
	stateScript[17]						= "OnBoltPull";
	stateTimeoutValue[17]				= 0.75;
	stateTransitionOnTimeout[17]     	= "BoltForward";
	stateWaitForTimeout[17]				= true;
	StateSequence[17]					= "Reload1";

	stateName[18]						= "BoltForward";
	stateScript[18]						= "OnBoltForward";
	stateTimeoutValue[18]				= 0.6;
	stateTransitionOnTimeout[18]     	= "Ready";
	stateWaitForTimeout[18]				= true;
	StateSequence[18]					= "Reload2";
	
	// Reloads - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	// Regular Reload
	stateName[12]						= "Reload";
	stateScript[12]						= "OnRoundInserted";
	stateTimeoutValue[12]				= 0.55;
	stateTransitionOnTimeout[12]     	= "ReloadFinish";
	stateWaitForTimeout[12]				= true;
	
	stateName[19]						= "ReloadFull";
	stateScript[19]						= "OnBoltPull";
	stateTimeoutValue[19]				= 0.75;
	stateTransitionOnTimeout[19]     	= "Reload";
	stateWaitForTimeout[19]				= true;
	StateSequence[19]					= "Reload1";

	// Finish reloading
	stateName[13]						= "ReloadFinish";
	stateScript[13]						= "OnShottyReloaded";	// Cuz it functions like a shotgun
	stateTimeoutValue[13]				= 0.01;
	stateTransitionOnTimeout[13]     	= "ReloadCheckC";
	stateWaitForTimeout[13]				= true;
	
	// Reload checks
	stateName[14]						= "ReloadCheckC";
	stateScript[14]						= "onReloadCheck";
	stateTimeoutValue[14]				= 0.01;
	stateTransitionOnTriggerDown[14]	= "BoltForward";
	stateTransitionOnTimeout[14]     	= "ReloadCheckD";
	
	stateName[15]						= "ReLoadCheckD";
	stateTransitionOnAmmo[15]			= "BoltForward";
	stateTransitionOnNoAmmo[15]			= "Reload";
};

package SnipersRCool
{
	function WeaponImage::onBoltPull(%this, %obj, %slot)
	{
		%obj.playThread(2, shiftleft);
		%obj.schedule(100, playThread, 2, plant);
		displayAmmo(%obj, %this);
		serverPlay3D(SniperBackSound, %obj.getPosition());
	}
	
	function WeaponImage::onBoltForward(%this, %obj, %slot)
	{
		%obj.playThread(2, shiftright);
		%obj.schedule(100, playThread, 2, plant);
		displayAmmo(%obj, %this);
		serverPlay3D(SniperForwardSound, %obj.getPosition());
	}
};
activatePackage(SnipersRCool);

function HKSniperRifleImage::onFire(%this, %obj, %slot)
{
	%rand = getRandom(0, 2);
	if(%rand == 1)
	{
		%this.raycastExplosionBrickSound = ObjHitBSound;
		%this.raycastExplosionPlayerSound = PlayerHitBSound;
	}
	else if(%rand == 2)
	{
		%this.raycastExplosionBrickSound = ObjHitCSound;
		%this.raycastExplosionPlayerSound = PlayerHitCSound;
	}
	else
	{
		%this.raycastExplosionBrickSound = ObjHitASound;
		%this.raycastExplosionPlayerSound = PlayerHitASound;
	}
	parent::onFire(%this, %obj, %slot);
	%obj.playThread(2, plant);
}